import java.io.DataInputStream;
import java.io.DataOutputStream;
import javax.microedition.io.Connector;
import javax.microedition.io.SocketConnection;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author eWonSupport_Adm
 */


public class WebClient {
    
        private static SocketConnection sc  = null;
        private static DataOutputStream os = null;
        private static DataInputStream  is  = null;
        private static boolean isConnectedHTTP = false;
        
        public static String ServerIP = null;
    
        public static void OpenHTTPConnection() throws Exception
        {
            String connectString = "socket://"+ServerIP+":80";

            try
            {
                if (isConnectedHTTP == false)
                {
                    // a socket connection is established with the remote server.
                    sc = (SocketConnection) Connector.open(connectString);

                    os = sc.openDataOutputStream();
                    is = sc.openDataInputStream();
                    isConnectedHTTP = true;
                }
                
            }
            catch (Exception e)
            {
                Exception newException = new Exception("WEATHERSTATION ERROR (OpenHTTPConnection): " + e.getMessage());
                throw newException;
            }

        }
    
        public static void CloseHTTPConnection() throws Exception
        {
            try {
               if (isConnectedHTTP == true)
               {           

                    is.close();
                    os.close();
                    sc.close();
                    isConnectedHTTP = false;

               }
            } catch (Exception e) {
                Exception newException = new Exception("WEATHERSTATION ERROR (CloseHTTPConnection): " + e.getMessage());
                throw newException;
            }
        }
    
        public static void CollectTags() throws Exception
        {
            try {
                OpenHTTPConnection();

                
                String HTTPResponse = HttpGet("/livedata.htm");
                
                //read value from XML Response
                String ResponseBody = HTTPResponse.substring(HTTPResponse.indexOf("\r\n\r\n")+ 4); //get rid of HTTP header
                
                Items.CleanList();
                //Parse File
                int StartSearchIndex = 0;
                int k=0;

                while(true)
                {

                    String ParamName_HtmlTag = "<input name=\"";
                    int Name_PosStart = ResponseBody.indexOf(ParamName_HtmlTag, StartSearchIndex) + ParamName_HtmlTag.length();           
                    int Name_PosEnd = ResponseBody.indexOf("\"", Name_PosStart);

                    String ParamValue_HtmlTag = "value=\"";                  
                    int Value_PosStart = ResponseBody.indexOf(ParamValue_HtmlTag, Name_PosStart) + ParamValue_HtmlTag.length();
                    int Value_PosEnd = ResponseBody.indexOf("\"", Value_PosStart);

                    String name = ResponseBody.substring(Name_PosStart, Name_PosEnd);
                    String value = ResponseBody.substring(Value_PosStart, Value_PosEnd);
                    
                    Items.SetValue(name,value);
                    
                    if("rainofyearly".equals(name)) //last Input
                        break;

                    StartSearchIndex = Value_PosEnd;  
                    
                    //Watchdog
                    k++;
                    if (k>100)//Invalid file
                    {                        
                        Items.CleanList();
                        Exception newException = new Exception("WEATHERSTATION ERROR (CollectTags): Invalid file - Loop 100 times");
                        throw newException;
                    }
                  
                }

                CloseHTTPConnection();
                
            } catch (Exception e) {
                Exception newException = new Exception("WEATHERSTATION ERROR (CollectTags): " + e.getMessage());
                throw newException;
            }
            finally
            {
                 CloseHTTPConnection();
            }

        }
        
       
        private static String HttpGet(String URL) throws Exception
        {
             try {
                StringBuffer sb = new StringBuffer();
                sb.append("GET ").append(URL).append(" HTTP/1.1"+ "\r\n");
                sb.append("Content-Type: text/html");
                sb.append("Host: ").append(ServerIP).append("\r\n\r\n");       
                //sb.append("Connection: Keep-Alive"+ "\r\n\r\n");         

                String GetRequest = sb.toString();


                os.write(GetRequest.getBytes());

                
                /* Read Data */
                StringBuffer str = new StringBuffer();
                int  ch;
                long timeSaved = System.currentTimeMillis() + 1500 ;
                long CurTime = System.currentTimeMillis();

                while(timeSaved > CurTime) //Timeout of 1500 millesec
                 {
                     CurTime = System.currentTimeMillis();
                     if (is.available() != 0)
                     {
                          timeSaved = CurTime + 20; //after the first byte 20 ms max before next char or give up
                          ch = (char) is.read();
                          if (ch != -1)
                             str.append((char)ch);
                      }
                }               
                

                return str.toString();
                
            } catch (Exception e) {
                Exception newException = new Exception("WEATHERSTATION ERROR (HttpGet): " + e.getMessage());
                throw newException;
            }
        }
}

